#include <PalmOS.h>
#include "DB.h"
#include "dcCalls.h"

void UI();			//main ui



void handleNotif(SysNotifyParamType* p){
	
	if(p->notifyType!=sysNotifyAppLaunchingEvent){
		
		ErrAlertCustom(0,"Got unexpected notification","DynaClockUI:",NULL);
		
	}
	else if(dcIsEnabled()){
		
		UInt32 crid;
		DmOpenRef db;
		dbRecType rec;
		
		
		DmDatabaseInfo(((SysNotifyAppLaunchOrQuitType*)(p->notifyDetailsP))->cardNo,
			((SysNotifyAppLaunchOrQuitType*)(p->notifyDetailsP))->dbID,NULL,NULL,NULL,NULL,
			NULL,NULL,NULL,NULL,NULL,NULL,&crid);
		
		
		db=openDb();
		
		if(!getRecord(db,crid,&rec) || rec.minState==0xFFFFFFFF){	//try get app's setting
			
			if(!getRecord(db,SYSTEM_CRID,&rec)){					//if no luck, OR SET TO "SYS" try get default system
																	// setting
				
				rec.maxState=dcGetNumStates()-1;					//if no luck, allow all, minState is already set
																	// inside "getRecord()"
				
			}
		}
		
		DmCloseDatabase(db);
		
		dcSetNewBounds(rec.minState,rec.maxState);	//set new app's speed bounds
		
	}
}

void setup(){
	
	UInt16 cardNo;
	LocalID LID;
	
	
	SysCurAppDatabase(&cardNo,&LID);
	
	SysNotifyRegister(cardNo,LID, sysNotifyAppLaunchingEvent,NULL,sysNotifyNormalPriority,0);
	
}

void makeSysRecord(){
	
	DmOpenRef db;
	dbRecType rec;
	
	db=openDb();
	
	if(!getRecord(db,SYSTEM_CRID,&rec)){		//need to make a system record
		
		rec.maxState=dcGetNumStates()-1;
		
		setRecord(db,SYSTEM_CRID,&rec);
	}
	
	DmCloseDatabase(db);
	
}


UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags){
	
	if(cmd==0){
		
		setup();
		
		if(dcIsEnabled()){
			
			UInt32 od,d=16;
			
			WinScreenMode(winScreenModeGet,NULL,NULL,&od,NULL);
			WinScreenMode(winScreenModeSet,NULL,NULL,&d,NULL);		//run in 16-bit color mode
			
			makeSysRecord();
			
			UI();
			
			WinScreenMode(winScreenModeSet,NULL,NULL,&od,NULL);
			
		}
		else{
			
			ErrAlertCustom(0,"Dynaclock cannot be found in memory. Is it running?","DynaClockUI:",NULL);
			
		}
	}
	else if(cmd==5){
		
		setup();
		
	}
	else if(cmd==51){
	
		handleNotif(cmdPBP);
		
	}
	
	return errNone;
}
