#include "PalmOs.h"
#include "DB.h"




DmOpenRef openDb(){
	
	DmOpenRef db;
	
	DmCreateDatabase(0,DB_NAME,DB_CRID,DB_TYPE,true);	//create db. if already exists, this is ignored
	
	
	db=DmOpenDatabaseByTypeCreator(DB_TYPE,DB_CRID,dmModeReadWrite);
	
	if(!db){
		
		SysFatalAlert("Cannot open/create database. This is really bad.");
		
	}
	
	return db;
}

Boolean getRecord(DmOpenRef db,UInt32 crid,dbRecType* rec){
	
	MemHandle mh;
	UInt16 idx;
	
	
	idx=DmFindResource(db,crid,0,NULL);
	
	if(idx==dmInvalidRecIndex){
		
		MemSet(rec,sizeof(dbRecType),0);
		
		return false;
	}
	else{
		
		mh=DmGetResourceIndex(db,idx);
		
		MemMove(rec,MemHandleLock(mh),sizeof(dbRecType));
		
		MemHandleUnlock(mh);
		DmReleaseResource(mh);
		
		return true;
	}
}

void setRecord(DmOpenRef db,UInt32 crid,dbRecType* rec){
	
	MemHandle mh;
	UInt16 idx;
	
	
	idx=DmFindResource(db,crid,0,NULL);
	
	if(idx==dmInvalidRecIndex){	//new record
		
		mh=DmNewResource(db,crid,0,sizeof(dbRecType));
	}
	else{
		
		mh=DmGetResourceIndex(db,idx);
		
	}
	
	if(mh){
		
		DmWrite(MemHandleLock(mh),0,rec,sizeof(dbRecType));
		
		MemHandleUnlock(mh);
		
		DmReleaseResource(mh);
	}
	else{
		
		ErrAlertCustom(0,"Cannot save a record to the database","DynaClockUI:",NULL);
		
	}
}








