#include <PalmOS.h>
#include "dcCalls.h"






UInt32 swap32(UInt32 x){
	
	return	((((x) >> 24) & 0x00FF)	|
			(((x) >>  8) & 0xFF00)	|
			(((x) & 0xFF00) <<  8)	|
			(((x) & 0x00FF) << 24));
			
}

dynaclockExports* dc_prv_getExportsTable(){
	
	dynaclockExports* e;
	
	if(FtrGet('PpDC','aG',(UInt32*)&e)!=errNone){
		
		e=NULL;
		
	}
	else if(swap32(e->signature)!='DyC2'){
		
		e=NULL;							//invalid signature -> better not try anything
		
	}
	
	return e;
}



Boolean dcIsEnabled(){
	
	return dc_prv_getExportsTable()!=NULL;
	
}

UInt32 dcGetNumStates(){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_getNumStates,0);
	
}

UInt32 dcGetStateCpu(UInt32 state){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_getStateCpu,state);
	
}

UInt32 dcGetStateBus(UInt32 state){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_getStateBus,state);
	
}

UInt32 dcGetStateMem(UInt32 state){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_getStateMem,state);
	
}

UInt32 dcGetActiveState(){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_getActiveState,0);
	
}

UInt32 dcSetActiveState(UInt32 newState){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_setActiveState,newState);
	
}

UInt32 dcGetLockStatus(){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_getLockStatus,0);
	
}

UInt32 dcSetLockStatus(UInt32 newState){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_setLockStatus,newState);
	
}

UInt32 dcGetLowestState(){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_getLowestState,0);
	
}

UInt32 dcGetHighestState(){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_getHighestState,0);
	
}

UInt32 dcSetLowestState(UInt32 newState){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_setLowestState,newState);
	
}

UInt32 dcSetHighestState(UInt32 newState){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_setHighestState,newState);
	
}

UInt32 dcGetAvgCpuSpeed(){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_getAvgCpuSpeed,0);
	
}

UInt32 dcGetAvgBusSpeed(){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_getAvgBusSpeed,0);
	
}

UInt32 dcGetAvgMemSpeed(){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_getAvgMemSpeed,0);
	
}

UInt32 dcGetAvgPowerState(){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_getAvgPowerState,0);
	
}

void dcSetNewBounds(UInt32 minState,UInt32 maxState){
	
	UInt32 curr;
	
	dcSetLockStatus(1);				//lock in current state;
	dcSetLowestState(0);			//set lowest as 0,so next call suceeds
	dcSetHighestState(maxState);	//set max
	dcSetLowestState(minState);		//set min
	
	curr=dcGetActiveState();
	
	if(curr<minState){
		
		curr=minState;
		
	}
	if(curr>maxState){
		
		curr=maxState;
		
	}
	
	dcSetActiveState(curr);			//set to a value in range
	dcSetLockStatus(0);				//unlock
}

UInt32 dcGetRegState(){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_getRegState,0);
	
}

void dcSetNewKey(UInt32 key){
	
	CALL_DC_FUNC(dc_prv_getExportsTable(),dc_setNewKey,key);
	
}

UInt32 dcGetUniqID(){
	
	return CALL_DC_FUNC(dc_prv_getExportsTable(),dc_getUniqID,0);
	
}