#ifndef _DC_CALLS_H_
#define _DC_CALLS_H_

#include <PalmOS.h>
#include <PceNativeCall.h>

#define CALL_DC_FUNC(exports,func,param)	PceNativeCall((void*)swap32(exports->func),(void*)(param))


typedef struct{
	
	UInt32 signature;				//used to make sure this structure contains what we expect
	
	UInt32 dc_getNumStates;			//exported functions
	UInt32 dc_getStateCpu;
	UInt32 dc_getStateBus;
	UInt32 dc_getStateMem;
	UInt32 dc_getActiveState;
	UInt32 dc_setActiveState;
	UInt32 dc_getLockStatus;
	UInt32 dc_setLockStatus;
	UInt32 dc_getLowestState;
	UInt32 dc_getHighestState;
	UInt32 dc_setLowestState;
	UInt32 dc_setHighestState;
	UInt32 dc_getAvgCpuSpeed;
	UInt32 dc_getAvgBusSpeed;
	UInt32 dc_getAvgMemSpeed;
	UInt32 dc_getAvgPowerState;
	UInt32 dc_getRegState;
	UInt32 dc_getUniqID;
	UInt32 dc_setNewKey;
	
}dynaclockExports;



Boolean dcIsEnabled();						//see if DC is present and running
UInt32 dcGetNumStates();					//get total number of states
UInt32 dcGetStateCpu(UInt32 state);			//get a state's cpu speed
UInt32 dcGetStateBus(UInt32 state);			//get a state's bus speed
UInt32 dcGetStateMem(UInt32 state);			//get a state's mem speed
UInt32 dcGetActiveState();					//get current state
UInt32 dcSetActiveState(UInt32 newState);	//set current state
UInt32 dcGetLockStatus();					//get current lock status
UInt32 dcSetLockStatus(UInt32 newState);	//set current lock status
UInt32 dcGetLowestState();					//set curr lowest allowable state
UInt32 dcGetHighestState();					//set curr top allowable state
UInt32 dcSetLowestState(UInt32 newState);	//set curr lowest allowable state
UInt32 dcSetHighestState(UInt32 newState);	//set curr top allowable state
UInt32 dcGetAvgCpuSpeed();					//x100
UInt32 dcGetAvgBusSpeed();					//x100
UInt32 dcGetAvgMemSpeed();					//x100
UInt32 dcGetAvgPowerState();				//x100
UInt32 dcGetRegState();						//get current reg state. 0xFFFFFFFF=registered, else # of seconds of trial left
UInt32 dcGetUniqID();						//get unique registration id
void dcSetNewKey(UInt32 key);				//set registration key
void dcSetNewBounds(UInt32 minState,UInt32 maxState);


#endif